WSMOUSED(8)

NAME
wsmoused - multipurpose mouse daemon

SYNOPSIS
wsmoused [-d device] [-f conf_file] [-m modes] [-n]

DESCRIPTION
The wsmoused daemon provides mouse support in console, allowing copying and pasting text. The left mouse button is used to select text when held and you use the right button to paste it in the active console.

Supported options are as follows:

-d device
    specifies the device file to be used as the wsmouse(4) device. Defaults to /dev/wsmouse.

-f conf_file
    specifies the configuration file to be used. Defaults to /etc/wsmoused.conf.

-m modes
    specifies which modes should be activated. Mode names are given in the argument as a whitespace separated list. Overrides the ‘modes’ directive in the configuration file.

-n  do not fork in the background (for debugging purposes). Overrides the ‘nodaemon’ directive in the configuration file.

Many other details can be tuned. See wsmoused.conf(5) for more information.

wsmoused is designed to be a multipurpose mouse daemon. Functionality is provided through independent modes, enabled either through the -m flag or through the ‘modes’ property in the configuration file (the former takes precedence).

  The action mode
The ‘action’ mode executes commands upon receiving mouse button events. Commands can be associated on a button basis, and can differentiate between push or release events.

  The selection mode
The ‘selection’ mode provides visual copy and paste support in text consoles when using the wscons(4) device. A selection is created by clicking with the primary mouse button at any point on the screen and dragging it while clicked. When the button is released, the selected text is copied to an internal buffer for further pasting with the secondary button.

FILES
/dev/ttyE[0-n]
    tty devices
/dev/ttyEstat
    wsdisplay status notification device
/dev/wsmouse[0-n]
    mouse control device
/etc/wsmoused.conf
    default configuration file

SEE ALSO
su(1), wscons(4), wsdisplay(4), wsmouse(4), rc.conf(5), ttys(5), wscons.conf(5), wsmoused.conf(5), moused(8), rc.subr(8)

HISTORY
The wsmoused command first appeared in NetBSD 2.0.

AUTHORS
The wsmoused command was developed by Julio M. Merino Vidal <jmmv@NetBSD.org>.

CAVEATS
wsmoused does work properly only with display drivers, which implement WSDISPLAYIO_GETWSCHAR and WSDISPLAYIO_PUTWSCHAR ioctls. Currently only vga(4) and drivers utilizing vcons(9) support it.

SECURITY CONSIDERATIONS
When using the ‘action’ mode, commands specified in the configuration file are executed as the user who started the daemon. By default, this user is ‘root’ when using the rc.subr(8) framework. You should set ‘wsmoused_user="<some_user>"’ in rc.conf(5) to a safer user (and adjust file permissions accordingly) if the commands you want to execute do not require superuser privileges. An alternative is to use su(1) as part of the command string in the configuration file.

NOTES
The following notes apply to all work modes:

•   When switching from the X screen to a text terminal, there is a small delay (five seconds) until the mouse works again. This time is used by X to close the mouse device properly.

The following notes apply to the ‘selection’ mode only:

•   The mouse cursor is only visible for a short period of time. It will disappear when you stop moving it to avoid console corruption (which happens if it is visible and there is text output).

•   You need to change the getty program which is run in the first virtual terminal to use /dev/ttyE0 instead of /dev/console. To do this, edit /etc/ttys and /etc/wscons.conf.